/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef SHOW_CHART_H
#define SHOW_CHART_H

#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Chart.H>
#include <stdio.h>

/**
 *\file Show_chart.h
 *\date  Created on: 01-mag-2009
 *\author  Author: Claudio Salvadori
 *\brief  Function to draw histogram using FLTK libraries
 */

/**	\brief Function to initialize the window to draw the chart. This function has to be called
*	 before the function that execute renderImage \see renderImage */
void initChart(void);

/**	\brief Function to draw chart
* 	\param image 	pointer to the histogram vector
*	\param s		vector size 
*/
void renderChart(int *h, unsigned int s);


#endif