/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file Show_chart.cpp
 *\brief  Chart rendering function development
 */
#include "Show_chart.h"

static Fl_Double_Window *chart_wnd = (Fl_Double_Window *) 0;
static Fl_Chart *m_chart = (Fl_Chart *) 0;

/*TODO insert the chart type in the init function*/
void initChart(void){
	if(chart_wnd  == (Fl_Double_Window *) 0){
		{
			chart_wnd  = new Fl_Double_Window(1300, 500, "");
			chart_wnd ->box(FL_BORDER_BOX);
			{
				//m_chart
				m_chart = new Fl_Chart(20, 20, chart_wnd->w()-40, chart_wnd->h()-40, "");
				m_chart->bounds (0, 20000);
				m_chart->type(FL_BAR_CHART);
				m_chart->autosize(1);
			}
			chart_wnd ->end();
		}
		chart_wnd->show();
		Fl::check();
	}
	return;
}

void renderChart(int *h, unsigned int s){
	fflush(stdout);

	m_chart->clear();	
	
	for(unsigned int i = 0; i < s; i++) {
		m_chart->add((double)(*(h + i)) / 100, NULL, FL_GREEN);
   	}
	
	m_chart->redraw();
	Fl::check();
	
	return;
}


